# CHANGELOG

## 0.10.8
* FIX: Ingredients in very old versions of Purr were not importing because of inconsistent formatting (PR: #470)
* FIX: Replacing 2 WPRM block recipes now works as expected--each imported recipe is replaced by their respective create card instead of the same create card (issue: #458 - PR: #464)
* FIX: embedded Mediavine videos in WPRM now import (issue: #461 - PR: #469)
* FIX: WPRM `fat` field is now imported properly (issue: #467 - PR: #469)
* FIX: WPRM empty custom time field is being imported correctly (issue: #465 - PR: #469)
* FIX: Can perform single card imports within Gutenberg for classic shortcodes (issue: #486 - PR: #487)
* FIX: WP Tasty imports from Gutenberg no longer remove the following paragraph of content (PR: #487)

## 0.10.7
* FIX: Image functions use the updated Create namespace after Create 1.6.0 update

## 0.10.6
* FIX: Import cuisine and keywords from Tasty
* FIX: Reimport previously missing cuisine and keywords from Tasty
* FIX: Import WPURP cuisines as names, not ids
* FIX: Imports WPRM global links
* ENHANCEMENT: Makes click areas more distinct when verifying recipes
* ENHANCEMENT: Adds disclaimer about creating categories

## 0.10.5
* FIX: Importer no longer crashes when trying to modify or add a link in the imported recipe
* FIX: Meal Planner Pro recipe reviews are now properly imported--previously imported recipes are fixed
* FIX: Gutenberg to Create conversion now successfully imports and replaces self-closing blocks
* ENHANCEMENT: "Rescan" button is visible on all Importers screens

## 0.10.4
* FIX: WPRM recipes now show up in bulk import for all users
* FIX: Ingredient links in WPRM now import properly
* FIX: WPRM nutrition import is fixed after structure change
* FIX: Custom time labels are now imported properly
* ENHANCEMENT: The "Rescan" button is always visible now
* ENHANCEMENT: Always attempts to import ratings from SRP in case of prior conversion oddities

## 0.10.3
* FEATURE: YouTube, Vimeo, and Mediavine videos now import from WPRM and Tasty recipes
* FIX: Empty nutrition values in Purr no longer import as 0
* FIX: Descriptions in WPRM retain italic, underline, bold, and link formatting

## 0.10.1
* FIX: Individual post imports and WPRM imports now working

## 0.10.0
* FIX: Fixed an issue where WPRM recipes weren't being found if a draft had the same parent post
* FIX: Gutenberg importer no longer crashes if Create loads slowly
* FEATURE: Add disclaimer dialog before enabling bulk importer

## 0.9.15
* FIX: Importing in the classic editor no longer wraps post content in `<p>` tags
* ENHANCEMENT: Adds a notice to save post contents before completing Import process

## 0.9.12
* FIX: Ensure invalidly formatted times don't stop importer from succeeding
* FIX: Attempts Easy Recipe replace even without the `endeasyrecipe` tag

## 0.9.11
* FIX: Links in ingredients now import as expected
* FIX: Import Recipes button only shows up in main editor TinyMCE

## 0.9.10
* FIX: Recipe conversion modal in Gutenberg is brought to the front
* FIX: Recipe importer can now move on to the Verify & Replace stages
* FIX: Clicking "Rescan" actually rescans

## 0.9.9
* FIX: WP Ultimate Recipes no longer show up as Purr recipes
* ENHANCEMENT: Initial request to find recipes is much faster and results are cached

## 0.9.8
* FEATURE: Can now import recipes from most plugins while editing a post in Gutenberg
* FIX: Recipes imported during beta testing (0.3 and below) are now counted as previously imported

## 0.9.7
* FEATURE: Recipes can now be imported from Gutenberg posts
* FIX: Purr recipe ingredients now import links correctly
* FIX: Purr recipe ingredient headings now import correctly
* FIX: Plugin no longer crashes on Zip Recipe imports if Zip Recipe ratings database doesn't exist
* FIX: Simple Recipes Pro ratings now link to imported Create cards

## 0.9.6
* FIX: Yummly recipes now show up
* FIX: Instructions import as ordered lists in EZR again
* FIX: Removes some code that could cause Importers to not show the first screen
* ENHANCEMENT: Speed up canonical post search
* ENHANCEMENT: Improve error messaging

## 0.9.5
* FIX: Initial importer screen now shows when there are remaining recipes
* FIX: Replace no longer gives an error when successful
* FIX: Number of servings correctly imports for WPRM
* ENHANCEMENT: Add reimporter support for WPRM

## 0.9.4
* ENHANCEMENT: Add ability to filter out recipes that aren't embedded in a post

## 0.9.2
* FIX: WPRM rating imports from comments are fixed

## 0.9.1
* FIX: Importer wouldn't finish imports

## 0.9.0
* FEATURE: Adds support for Cookbook recipes

## 0.8.3
* FIX: Minor bug fixes

## 0.8.2
* FIX: MPP imports recipes again
* FIX: WPRM ratings imports are fixed

## 0.8.1
* FIX: App no longer crashes if you haven't imported any recipes

## 0.8.0
* FEATURE: Adds a Reimport tab to the importer for re-importing data from cards
* ENHANCEMENT: Adds support for replacing Tasty recipes Gutenberg shortcodes

## 0.7.1
* FIX: Editor modal now opens on import verification step

## 0.7.0
* FIX: EasyRecipe cooking durations greater than 1 hour are now imported properly
* FIX: Support for time formatting in EasyRecipe versions < 3.0.0
* FIX: Properly imports saturated fat, unsaturated fat, and trans fat in EasyRecipe

## 0.6.2
* FIX: Ingredients with multiple asterisks now import correctly
* FIX: Purr Importer now converts `<h4>` tags in Instructions to `<h3>`
* FIX: When closing nested modals, the WP dashboard menu no longer overlaps

## 0.6.1
* FIX: Reviews left when Cookbook, WPRM, EZ Recipe, or SRP were active are now imported with Tasty recipe imports

## 0.5.0
* FEATURE: Use filenames in assets
* FIX: Correct admin notice Create plugin is not activated

## 0.4.7
* FIX: Recipe titles now show again in single post importer

## 0.4.5
* ENHANCEMENT: Adding Namespace to Admin CSS
* ENHANCEMENT: Missing fields warnings stay in the Importer
* ENHANCEMENT: Imported recipes separated by plugin
* ENHANCEMENT: Added support for older `[cft format=0]` Purr recipes
* FIX: Recipes can now only be imported once
* FIX: Better support for shortcode style markup in EasyRecipe imports
* FIX: Importer does not crash when a replacement fails
* FIX: Ratings/reviews that were imported but didn't show up now do
* FIX: Links in Zip recipes have better support

## 0.4.3
* FEATURE: Instructions imported as list
* FIX: Prevent nutrition info from stripping decimals
* FIX: Meal Planner Pro now imports proper categories and cuisines
* FIX: Empty nutrition data is left empty
* FIX: WPRM properly decodes HTML entities

## 0.4.1
* FEATURE: Added support for importing Purr Recipe Cards
* FIX: Importers now properly import cook time
* FIX: Tasty Recipes now imports ingredients properly
* FIX: Meal Planner Pro prevents errors with time fields with no numbers
* FIX: Recipes already replaced are no longer shown in the importer

## 0.3.1
* FEATURE: Resets import progress from 0.2.x releases
* FIX: Fixes bug with Meal Planner Pro import

## 0.3.0
* ENHANCEMENT: UI Enhancement

## 0.2.10
* FEATURE: Add progress tracking to importer
* ENHANCEMENT: Add support for exposing Tasty Recipes ratings on import
* FIX: Improve support for importing SRP and WPRM ratings
* FIX: Convert all nutritional data to numeric values before importing

## 0.2.7
* FEATURE: Add support for Yummly
* FIX: Remove extra HTML from EasyRecipe titles
* FIX: Add backwards compatibility for SRP ratings
* FIX: Fix an issue with legacy SRP content not being replaced

## 0.2.6
* FEATURE: Adds bug reporting for recipes that couldn’t be replaced
* FIX: Removes setting the current user as recipe author by default
* FIX: Handle cases where SRP ingredients were added as paragraphs
* FIX: Prevent duplicate blank lines being added for older versions of SRP
* FIX: Prevent ingredients from "jumping" during importer verification

## 0.2
* FEATURE: Adds support for recipes that were imported into SRP

## 0.1.9
* FIX: Fixes bug with wrong Simple Recipes Pro recipes being replaced

## 0.1.7
* FEATURE: Adds support for older versions of Simple Recipes Pro
* FEATURE: Adds support for cook times in HH:MM format
* FEATURE: Improves formatting of imported descriptions
* FEATURE: Improve author assignments for imported recipes
* FIX: Remove remaining V1 Importer Files
* FIX: Fixes bugs with blank ingredients from Meal Planner Pro
* FIX: Add support for importing instruction images in Recipe Maker recipes

## 0.1.6
* FIX: Parse EasyRecipe shortcodes for import in all text content
* FIX: Fixed EasyRecipe ingredients grouping with `[b][/b]` style headings
* FIX: Fixed issue with WPRM instructions import
